#define _CRT_RAND_S

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <limits.h>
#include <windows.h>

unsigned getnum(void);
int openbook(unsigned book);

void *otzar;  // handle to otzar window
//default filenames, may change later
char infile[1024] = "C:\\OTZAR\\pqr0.txt", outfile[1024] = "C:\\OTZAR\\pq0.txt";

int
main(void)
{
    otzar = FindWindow("TOtzarMainForm", 0);
    return openbook(getnum());
}

unsigned
getnum(void)
{
    FILE *ifp, *ofp;
    if ((ifp = fopen("input.txt", "r")) != NULL)  // get otzar location
    {
        fscanf(ifp, "programdir=%[^\n]", infile);  // read until the newline
        fclose(ifp);
        size_t len = strlen(infile);
        memcpy(outfile, infile, len);
        memcpy(outfile + len, "pq0.txt", sizeof("pq0.txt"));
        memcpy(infile + len, "pqr0.txt", sizeof("pqr0.txt"));
    }
    
    if ((ofp = fopen(outfile, "w")) == NULL) return 0;
    fputs("getcurlistcount=", ofp);
    fclose(ofp);
    SendMessage(otzar, 2048, 0, 0);
    unsigned books = 0;
    if ((ifp = fopen(infile, "r")) == NULL) return 0;
    fscanf(ifp, "getcurlistcount=%u", &books);
    fclose(ifp);
    unsigned num;
    rand_s(&num);
    num = num / (double) UINT_MAX * books;
    return (num == 0)? books: num;
}

int
openbook(unsigned book)
{
    FILE *ofp;
    if ((ofp = fopen(outfile, "w")) == NULL) return -1;
    fprintf(ofp, "getcurlistrowbookid(%d)=", book - 1);
    fclose(ofp);
    SendMessage(otzar, 2048, 0, 0);
    int bookid = 0;
    FILE *ifp;
    if ((ifp = fopen(infile, "r")) == NULL) return -1;
    fscanf(ifp, "getcurlistrowbookid(%*d)=%d", &bookid);
    fclose(ifp);
    if ((ofp = fopen(outfile, "w")) == NULL) return -1;
    fprintf(ofp, "openbook=%d", bookid);
    fclose(ofp);
    SendMessage(otzar, 2048, 0, 0);
    return 0;
}
